unit PalUtils;

interface

uses
  Windows, SysUtils, Classes, Graphics, RGBHSVUtils,
  RGBHSLUtils, RGBCIEUtils, RGBCMYKUtils, HTMLColors, StrUtils,
  GraphUtil;

type
  TcxColorInfo = record
    Name: string;
    Color: TColor;
  end;

const
  clCustom = $2FFFFFFF;
  clTransparent = $3FFFFFFF;
   cxColorsByName: array[0..168] of TcxColorInfo = (
    (Name: 'Alice Blue';             Color: $00FFF8F0),
    (Name: 'Antique White';          Color: $00D7EBFA),
    (Name: 'Aqua';                   Color: clAqua),
    (Name: 'Aquamarine';             Color: $007FD4FF),
    (Name: 'Azure';                  Color: $00FFFFF0),
    (Name: 'Beige';                  Color: $00DCF5F5),
    (Name: 'Bisque';                 Color: $00C4E4FF),
    (Name: 'Black';                  Color: clBlack),
    (Name: 'Blanched Almond';        Color: $00CDFFFF),
    (Name: 'Blue';                   Color: clBlue),
    (Name: 'Blue Violet';            Color: $00E22B8A),
    (Name: 'Brown';                  Color: $002A2AA5),
    (Name: 'Burly Wood';             Color: $0087B8DE),
    (Name: 'Cadet Blue';             Color: $00A09E5F),
    (Name: 'Chartreuse';             Color: $0000FF7F),
    (Name: 'Chocolate';              Color: $001E69D2),
    (Name: 'Coral';                  Color: $00507FFF),
    (Name: 'Cornflower Blue';        Color: $00ED9564),
    (Name: 'Cornsilk';               Color: $00DCF8FF),
    (Name: 'Crimson';                Color: $003C14DC),
    (Name: 'Cyan';                   Color: $00FFFF00),
    (Name: 'Dark Blue';              Color: $008B0000),
    (Name: 'Dark Cyan';              Color: $008B8B00),
    (Name: 'Dark Goldenrod';         Color: $000B86B8),
    (Name: 'Dark Gray';              Color: $00A9A9A9),
    (Name: 'Dark Green';             Color: $00006400),
    (Name: 'Dark Khaki';             Color: $006BB7BD),
    (Name: 'Dark Magenta';           Color: $008B008B),
    (Name: 'Dark Olive Green';       Color: $002F6B55),
    (Name: 'Dark Orange';            Color: $00008CFF),
    (Name: 'Dark Orchid';            Color: $00CC3299),
    (Name: 'Dark Red';               Color: $0000008B),
    (Name: 'Dark Salmon';            Color: $007A96E9),
    (Name: 'Dark Sea Green';         Color: $008FBC8F),
    (Name: 'Dark Slate Blue';        Color: $008B3D48),
    (Name: 'Dark Slate Gray';        Color: $004F4F2F),
    (Name: 'Dark Turquoise';         Color: $00D1CE00),
    (Name: 'Dark Violet';            Color: $00D30094),
    (Name: 'Deep Pink';              Color: $009314FF),
    (Name: 'Deep Sky Blue';          Color: $00FFBF00),
    (Name: 'Dim Gray';               Color: $00696969),
    (Name: 'Dodger Blue';            Color: $00FF901E),
    (Name: 'Fire Brick';             Color: $002222B2),
    (Name: 'Floral White';           Color: $00F0FAFF),
    (Name: 'Forest Green';           Color: $00228B22),
    (Name: 'Fuchsia';                Color: $00FF00FF),
    (Name: 'Gainsboro';              Color: $00DCDCDC),
    (Name: 'Ghost White';            Color: $00FFF8F8),
    (Name: 'Gold';                   Color: $0000D7FF),
    (Name: 'Goldenrod';              Color: $0020A5DA),
    (Name: 'Gray';                   Color: clGray),
    (Name: 'Green';                  Color: clGreen),
    (Name: 'Green Yellow';           Color: $002FFFAD),
    (Name: 'Honeydew';               Color: $00F0FFF0),
    (Name: 'Hot Pink';               Color: $00B469FF),
    (Name: 'Indian Red';             Color: $005C5CCD),
    (Name: 'Indigo';                 Color: $0082004B),
    (Name: 'Ivory';                  Color: $00F0F0FF),
    (Name: 'Khaki';                  Color: $008CE6F0),
    (Name: 'Lavender';               Color: $00FAE6E6),
    (Name: 'Lavender Blush';         Color: $00F5F0FF),
    (Name: 'Lawn Green';             Color: $0000FC7C),
    (Name: 'Lemon Chiffon';          Color: $00CDFAFF),
    (Name: 'Light Blue';             Color: $00E6D8AD),
    (Name: 'Light Coral';            Color: $008080F0),
    (Name: 'Light Cyan';             Color: $00FFFFE0),
    (Name: 'Light Goldenrod Yellow'; Color: $00D2FAFA),
    (Name: 'Light Green';            Color: $0090EE90),
    (Name: 'Light Grey';             Color: $00D3D3D3),
    (Name: 'Light Pink';             Color: $00C1B6FF),
    (Name: 'Light Salmon';           Color: $007AA0FF),
    (Name: 'Light Sea Green';        Color: $00AAB220),
    (Name: 'Light Sky Blue';         Color: $00FACE87),
    (Name: 'Light Slate Gray';       Color: $00998877),
    (Name: 'Light Steel Blue';       Color: $00DEC4B0),
    (Name: 'Light Yellow';           Color: $00E0FFFF),
    (Name: 'Lime';                   Color: clLime),
    (Name: 'Lime Green';             Color: $0032CD32),
    (Name: 'Linen';                  Color: $00E6F0FA),
    (Name: 'Magenta';                Color: $00FF00FF),
    (Name: 'Maroon';                 Color: clMaroon),
    (Name: 'Medium Aquamarine';      Color: $00AACD66),
    (Name: 'Medium Blue';            Color: $00CD0000),
    (Name: 'Medium Orchid';          Color: $00D355BA),
    (Name: 'Medium Purple';          Color: $00DB7093),
    (Name: 'Medium Sea Green';       Color: $0071B33C),
    (Name: 'Medium Purple';          Color: $00DB7093),
    (Name: 'Medium Slate Blue';      Color: $00EE687B),
    (Name: 'Medium Spring Green';    Color: $009AFA00),
    (Name: 'Medium Turquoise';       Color: $00CCD148),
    (Name: 'Medium Violet Red';      Color: $008515C7),
    (Name: 'Midnight Blue';          Color: $00701919),
    (Name: 'Mint Cream';             Color: $00FAFFF5),
    (Name: 'Misty Rose';             Color: $00E1E4FF),
    (Name: 'Moccasin';               Color: $00B5E4FF),
    (Name: 'Navajo White';           Color: $00ADDEFF),
    (Name: 'Navy';                   Color: clNavy),
    (Name: 'Old Lace';               Color: $00E6F5FD),
    (Name: 'Olive';                  Color: $00008080),
    (Name: 'Olive Drab';             Color: $00238E6B),
    (Name: 'Orange';                 Color: $0000A5FF),
    (Name: 'Orange Red';             Color: $000045FF),
    (Name: 'Orchid';                 Color: $00D670DA),
    (Name: 'Pale Goldenrod';         Color: $00AAE8EE),
    (Name: 'Pale Green';             Color: $0098FB98),
    (Name: 'Pale Turquoise';         Color: $00EEEEAF),
    (Name: 'Pale Violet Red';        Color: $009370DB),
    (Name: 'Papaya Whip';            Color: $00D5EFFF),
    (Name: 'Peach Puff';             Color: $00BDDBFF),
    (Name: 'Peru';                   Color: $003F85CD),
    (Name: 'Pink';                   Color: $00CBC0FF),
    (Name: 'Plum';                   Color: $00DDA0DD),
    (Name: 'Powder Blue';            Color: $00E6E0B0),
    (Name: 'Purple';                 Color: $00800080),
    (Name: 'Red';                    Color: clRed),
    (Name: 'Rosy Brown';             Color: $008F8FBC),
    (Name: 'Royal Blue';             Color: $00E16941),
    (Name: 'Saddle Brown';           Color: $0013458B),
    (Name: 'Salmon';                 Color: $007280FA),
    (Name: 'Sandy Brown';            Color: $0060A4F4),
    (Name: 'Sea Green';              Color: $00578B2E),
    (Name: 'Seashell';               Color: $00EEF5FF),
    (Name: 'Sienna';                 Color: $002D52A0),
    (Name: 'Silver';                 Color: $00C0C0C0),
    (Name: 'Sky Blue';               Color: $00EBCE87),
    (Name: 'Slate Blue';             Color: $00CD5A6A),
    (Name: 'Slate Gray';             Color: $00908070),
    (Name: 'Snow';                   Color: $00FAFAFF),
    (Name: 'Spring Green';           Color: $007FFF00),
    (Name: 'Steel Blue';             Color: $00B48246),
    (Name: 'Tan';                    Color: $008CB4D2),
    (Name: 'Teal';                   Color: clTeal),
    (Name: 'Thistle';                Color: $00D8BFD8),
    (Name: 'Tomato';                 Color: $004763FD),
    (Name: 'Turquoise';              Color: $00D0E040),
    (Name: 'Violet';                 Color: $00EE82EE),
    (Name: 'Wheat';                  Color: $00B3DEF5),
    (Name: 'White';                  Color: clWhite),
    (Name: 'White Smoke';            Color: $00F5F5F5),
    (Name: 'Yellow';                 Color: clYellow),
    (Name: 'Yellow Green';           Color: $0032CD9A),

    (Name: 'Active Border';          Color: clActiveBorder),
    (Name: 'Active Caption';         Color: clActiveCaption),
    (Name: 'Appwork Space';          Color: clAppWorkSpace),
    (Name: 'Background';             Color: clBackground),
    (Name: 'Button Face';            Color: clBtnFace),
    (Name: 'Button Highlight';       Color: clBtnHighlight),
    (Name: 'Button Shadow';          Color: clBtnShadow),
    (Name: 'Button Text';            Color: clBtnText),
    (Name: 'Caption Text';           Color: clCaptionText),
    (Name: 'Gray Text';              Color: clGrayText),
    (Name: 'Highlight';              Color: clHighlight),
    (Name: 'Highlight Text';         Color: clHighlightText),
    (Name: 'Inactive Border';        Color: clInactiveBorder),
    (Name: 'Inactive Caption';       Color: clInactiveCaption),
    (Name: 'Inactive Caption Text';   Color: clInactiveCaptionText),
    (Name: 'Info Background';        Color: clInfoBk),
    (Name: 'Info Text';              Color: clInfoText),
    (Name: 'Menu';                   Color: clMenu),
    (Name: 'Menu Text';              Color: clMenuText),
    (Name: 'Scrollbar';              Color: clScrollBar),
    (Name: 'Threed Dark Shadow';     Color: cl3DDkShadow),
    (Name: 'Threed Face';            Color: clBtnFace),
    (Name: 'Threed Highlight';       Color: clHighlightText),
    (Name: 'Threed Light Shadow';    Color: cl3DLight),
    (Name: 'Threed Shadow';          Color: clBtnShadow),
    (Name: 'Window';                 Color: clWindow),
    (Name: 'Window Frame';           Color: clWindowFrame),
    (Name: 'Window Text';            Color: clWindowText)
  );

type
  TSortOrder = (soAscending, soDescending);
  TSortMode = (smRed, smGreen, smBlue, smHue, smSaturation, smLuminance,
    smValue, smNone, smCyan, smMagenta, smYellow, smBlacK, smCIEx, smCIEy,
    smCIEz, smCIEl, smCIEa, smCIEb);

  AcoColors = record
    Colors: array of TColor;
    Names: array of WideString;
    HasNames: boolean;
  end;

  // Convert TColor to HSL.
procedure ColorToHSL(var AColor: TColor; var H, S, L: byte);
// Convert HSL to TColor.
function HSLtoColor(H, S, L: byte): TColor;
// Convert AColor to a darker color of same hue. }
function DarkerColor(var AColor: TColor; const Adjustment: byte): TColor;
// Convert AColor to a lighter color of same hue.
function LighterColor(var AColor: TColor; const AAdjustment: byte): TColor;
// Convert AColor to Hex string.
function ColorToHex(const AColor: TColor): string;
// Get inverse color.
function InverseColor(AColor: TColor): TColor;
// Convert Decimal color value to RGB.
procedure AColorToRGB(const Color: Integer; out ARed, AGreen, ABlue: byte);
// Convert RGB to decimal value.
function RGBToColor(const ARed, AGreen, ABlue: byte): Integer;
{ Return contracting color of the passed color. }
function ContrastingColor(const AColor: TColor): TColor;
{ Get a contrasting color. }
function GetContrastingColor(AColor: TColor): TColor;
{ TColorToHex. }
function TColorToHex(Color: TColor): string;
{ HexToTColor. }
function HexToTColor(sColor: string): TColor;
// Get cxColorname from Color
function cxNameByColor(AColor: TColor; var AText: string): boolean;
// replaces passed strings with passed value
function ReplaceFlags(S: string; flags: array of string;
  value: Integer): string;
// replaces the appropriate tags with values in a hint format string
function FormatHint(fmt: string; c: TColor): string;
// converts a string value to TColor including clCustom and clTransparent
function mbStringToColor(S: string): TColor;
// converts a TColor to a string value including clCustom and clTransparent
function mbColorToString(c: TColor): string;
// return a string of a TColor with pretty color names
function ColorToPrettyName(const AColor: TColor): string;
// return a string of a TColor with pretty Web color names
function ColorToPrettyWebName(const AColor: TColor): string;
// return a cxColor as a string
function cxColorToString(AColor: TColor): string;
// blends two colors together in proportion C1 : C2 = W1 : 100 - W1, where 0 <= W1 <= 100
function Blend(C1, C2: TColor; W1: Integer): TColor;
// generates a white-color-black or a black-color-white gradient palette
function MakePalette(BaseColor: TColor; SortOrder: TSortOrder): string;
// generates a gradient palette from the given colors
function MakeGradientPalette(Colors: array of TColor): string;
// sorts colors in a string list
procedure SortPalColors(Colors: TStrings; SortMode: TSortMode;
  SortOrder: TSortOrder);
// reads JASC .pal file
function ReadJASCPal(PalFile: TFileName): string;
// saves a string list to a JASC .pal file
procedure SaveJASCPal(pal: TStrings; FileName: TFileName);
// reads Photoshop .aco file into an Aco record
function ReadPhotoshopAco(PalFile: TFileName): AcoColors;
// reads Photoshop .act file
function ReadPhotoshopAct(PalFile: TFileName): string;

implementation

uses Math;

procedure ColorToHSL(var AColor: TColor; var H, S, L: byte);
{ Convert TColor to HSL. }
var
  Dif, CCmax, CCmin, RC, GC, BC, TempH, TempS, TempL: Double;
begin
  AColor := ColorToRGB(AColor);
  RC := GetRValue(AColor) / 255;
  GC := GetGValue(AColor) / 255;
  BC := GetBValue(AColor) / 255;
  if RC > GC then
    CCmax := RC
  else
    CCmax := GC;
  if BC > CCmax then
    CCmax := BC;
  if RC < GC then
    CCmin := RC
  else
    CCmin := GC;
  if BC < CCmin then
    CCmin := BC;
  TempL := (CCmax + CCmin) / 2.0;
  if CCmax = CCmin then
  begin
    TempS := 0;
    TempH := 0;
  end
  else
  begin
    Dif := CCmax - CCmin;
    if TempL < 0.5 then
      TempS := Dif / (CCmax + CCmin)
    else
      TempS := Dif / (2.0 - CCmax - CCmin);
    if RC = CCmax then
      TempH := (GC - BC) / Dif
    else if GC = CCmax then
      TempH := 2.0 + (BC - RC) / Dif
    else
      TempH := 4.0 + (RC - GC) / Dif;
    TempH := TempH / 6;
    if TempH < 0 then
      TempH := TempH + 1;
  end;
  H := Round(240 * TempH);
  S := Round(240 * TempS);
  L := Round(240 * TempL);
end;

function HSLtoColor(H, S, L: byte): TColor;
{ Convert HSL to TColor. }
var
  HN, SN, LN, RD, GD, BD, V, M, SV, Fract, VSF, Mid1, Mid2: Double;
  R, G, B: byte;
  Sextant: Integer;
begin
  HN := H / 239;
  SN := S / 240;
  LN := L / 240;
  if LN < 0.5 then
    V := LN * (1.0 + SN)
  else
    V := LN + SN - LN * SN;
  if V <= 0 then
  begin
    RD := 0.0;
    GD := 0.0;
    BD := 0.0;
  end
  else
  begin
    M := LN + LN - V;
    SV := (V - M) / V;
    HN := HN * 6.0;
    Sextant := Trunc(HN);
    Fract := HN - Sextant;
    VSF := V * SV * Fract;
    Mid1 := M + VSF;
    Mid2 := V - VSF;
    case Sextant of
      0:
        begin
          RD := V;
          GD := Mid1;
          BD := M;
        end;
      1:
        begin
          RD := Mid2;
          GD := V;
          BD := M;
        end;
      2:
        begin
          RD := M;
          GD := V;
          BD := Mid1;
        end;
      3:
        begin
          RD := M;
          GD := Mid2;
          BD := V;
        end;
      4:
        begin
          RD := Mid1;
          GD := M;
          BD := V;
        end;
      5:
        begin
          RD := V;
          GD := M;
          BD := Mid2;
        end;
    else
      begin
        RD := V;
        GD := Mid1;
        BD := M;
      end;
    end;
  end;
  if RD > 1.0 then
    RD := 1.0;
  if GD > 1.0 then
    GD := 1.0;
  if BD > 1.0 then
    BD := 1.0;
  R := Round(RD * 255);
  G := Round(GD * 255);
  B := Round(BD * 255);
  Result := RGB(R, G, B);
end;

function DarkerColor(var AColor: TColor; const Adjustment: byte): TColor;
{ Convert AColor to a darker color of same hue. }
var
  iH, iSS, iL: byte;
begin
  ColorToHSL(AColor, iH, iSS, iL);
  Result := HSLtoColor(iH, iSS, Max(iL - Adjustment, 0));
end;

function LighterColor(var AColor: TColor; const AAdjustment: byte): TColor;
{ Convert AColor to a lighter color of same hue. }
var
  iH, iSS, iL: byte;
begin
  ColorToHSL(AColor, iH, iSS, iL);
  Result := HSLtoColor(iH, iSS, Min(iL + AAdjustment, 255));
end;

function ColorToHex(const AColor: TColor): string;
{ Convert AColor to Hex string. }
begin
  Result := '$' + IntToHex(ColorToRGB(AColor), 6);
end;

function InverseColor(AColor: TColor): TColor;
{ Get inverse color. }
var
  irgbColorRef: TColorRef;
  function Inv(B: byte): byte;
  begin
    if B > 128 then
      Result := 0
    else
      Result := 255;
  end;
begin
  irgbColorRef := ColorToRGB(AColor);
  irgbColorRef := RGB(Inv(GetRValue(irgbColorRef)), Inv(GetGValue(irgbColorRef)
    ), Inv(GetBValue(irgbColorRef)));
  Result := irgbColorRef;
end;

procedure AColorToRGB(const Color: Integer; out ARed, AGreen, ABlue: byte);
{ Convert Decimal color value to RGB. }
begin
  ARed := Color and $FF;
  AGreen := (Color shr 8) and $FF;
  ABlue := (Color shr 16) and $FF;
end;

function RGBToColor(const ARed, AGreen, ABlue: byte): Integer;
{ Convert RGB to decimal value. }
begin
  Result := ARed or (AGreen shl 8) or (ABlue shl 16);
end;

function ContrastingColor(const AColor: TColor): TColor;
{ Return contracting color of the passed color. }
begin
  if ((AColor and $FF) * 77 + ((AColor shr 8) and $FF) * 150 +
    ((AColor shr 16) and $FF) * 29) > 127 * 256 then
    Result := clBlack
  else
    Result := clWhite;
end;

function GetContrastingColor(AColor: TColor): TColor;
{ Get a contrasting color. }
begin
  AColor := ColorToRGB(AColor); { convert system-defined colors }
  Result := (AColor + $000080) and $0000FF + { red component }
    (AColor + $008000) and $00FF00 + { green component }
    (AColor + $800000) and $FF0000; { blue component }
end;

function GetContrastColor(AColor: TColor): TColor;
{ Get contrast color. }
begin
  AColor := ColorToRGB(AColor); { convert system-defined colors }
  if (AColor + AColor shr 8 + AColor shr 16) and $0000FF >= $180 then
    Result := clBlack
  else
    Result := clWhite;
end;

function TColorToHex(Color: TColor): string;
{ TColorToHex. }
begin
  Result := IntToHex(GetRValue(Color), 2) + IntToHex(GetGValue(Color), 2) +
    IntToHex(GetBValue(Color), 2);
end;

function HexToTColor(sColor: string): TColor;
{ HexToTColor. }
begin
  Result := RGB(StrToInt('$' + Copy(sColor, 1, 2)),
    StrToInt('$' + Copy(sColor, 3, 2)), StrToInt('$' + Copy(sColor, 5, 2)));
end;

function cxNameByColor(AColor: TColor; var AText: string): boolean;
var
  I: Integer;
begin
  Result := False;
  for I := Low(cxColorsByName) to High(cxColorsByName) do
    if AColor = cxColorsByName[I].Color then
    begin
      AText := cxColorsByName[I].Name;
      Result := True;
      Break;
    end;
end;

function ReplaceFlags(S: string; flags: array of string;
  value: Integer): string;
var
  I, p: Integer;
  V: string;
begin
  Result := S;
  V := IntToStr(value);
  for I := 0 to Length(flags) - 1 do
  begin
    p := Pos(flags[I], Result);
    if p > 0 then
    begin
      Delete(Result, p, Length(flags[I]));
      Insert(V, Result, p);
    end;
  end;
end;

function AnsiReplaceText(const AText, AFromText, AToText: string): string;
begin
  Result := StringReplace(AText, AFromText, AToText,
    [rfReplaceAll, rfIgnoreCase]);
end;

function FormatHint(fmt: string; c: TColor): string;
var
  H: string;
  ColorText: string;
begin
  H := AnsiReplaceText(fmt, '%hex', ColorToHex(c));
  H := AnsiReplaceText(H, '%cieL', IntToStr(Round(GetCIElValue(c))));
  H := AnsiReplaceText(H, '%cieA', IntToStr(Round(GetCIEaValue(c))));
  H := AnsiReplaceText(H, '%cieB', IntToStr(Round(GetCIEbValue(c))));
  H := AnsiReplaceText(H, '%cieX', IntToStr(Round(GetCIExValue(c))));
  H := AnsiReplaceText(H, '%cieY', IntToStr(Round(GetCIEyValue(c))));
  H := AnsiReplaceText(H, '%cieZ', IntToStr(Round(GetCIEzValue(c))));
  H := AnsiReplaceText(H, '%cieC', IntToStr(Round(GetCIEcValue(c))));
  H := AnsiReplaceText(H, '%cieH', IntToStr(Round(GetCIEhValue(c))));
  H := AnsiReplaceText(H, '%hslH', IntToStr(RGBHSLUtils.GetHValue(c)));
  H := AnsiReplaceText(H, '%hslS', IntToStr(RGBHSLUtils.GetSValue(c)));
  H := AnsiReplaceText(H, '%hslL', IntToStr(RGBHSLUtils.GetLValue(c)));
  H := AnsiReplaceText(H, '%hsvH', IntToStr(RGBHSVUtils.GetHValue(c)));
  H := AnsiReplaceText(H, '%hsvS', IntToStr(RGBHSVUtils.GetSValue(c)));
  H := AnsiReplaceText(H, '%hsvV', IntToStr(RGBHSVUtils.GetVValue(c)));
  H := AnsiReplaceText(H, '%r', IntToStr(GetRValue(c)));
  H := AnsiReplaceText(H, '%g', IntToStr(GetGValue(c)));
  H := AnsiReplaceText(H, '%b', IntToStr(GetBValue(c)));
  H := AnsiReplaceText(H, '%c', IntToStr(GetCValue(c)));
  H := AnsiReplaceText(H, '%m', IntToStr(GetMValue(c)));
  H := AnsiReplaceText(H, '%y', IntToStr(GetYValue(c)));
  H := AnsiReplaceText(H, '%k', IntToStr(GetKValue(c)));
  H := AnsiReplaceText(H, '%h', IntToStr(RGBHSLUtils.GetHValue(c)));
  H := AnsiReplaceText(H, '%s', IntToStr(RGBHSLUtils.GetSValue(c)));
  H := AnsiReplaceText(H, '%l', IntToStr(RGBHSLUtils.GetLValue(c)));
  H := AnsiReplaceText(H, '%v', IntToStr(RGBHSVUtils.GetVValue(c)));
  if cxNameByColor(c, ColorText) then
    H := AnsiReplaceText(H, '%x', ColorText)
  else
    // h := AnsiReplaceText( h, '%x', ColorToPrettyName( c ) );
    H := AnsiReplaceText(H, '%x', cxColorToString(c));
  // h := AnsiReplaceText( h, '%cs', ColorToString( c ) );
  Result := H;
end;

function mbStringToColor(S: string): TColor;
begin
  // remove spaces
  S := AnsiReplaceText(S, ' ', '');
  if SameText(S, 'clCustom') then
    Result := clCustom
  else if SameText(S, 'clTransparent') then
    Result := clTransparent
  else
    Result := StringToColor(S);
end;

function mbColorToString(c: TColor): string;
begin
  if c = clCustom then
    Result := 'Custom'
  else if c = clTransparent then
    Result := 'Transparent'
  else
    Result := ColorToString(c);
end;

function ColorToPrettyName(const AColor: TColor): string;
{ Return a string of a TColor }
var
  cs1: string;
begin
  Result := '';
  cs1 := ColorToString(AColor);
  if AnsiContainsText(cs1, 'cl') then
    Delete(cs1, 1, 2);
  Result := cs1;
end;

function ColorToPrettyWebName(const AColor: TColor): string;
{ Return a string of a TColor }
var
  cs1: string;
begin
  Result := '';
  cs1 := ColorToWebColorName(AColor);
  if AnsiContainsText(cs1, 'cl') then
    Delete(cs1, 1, 2);
  Result := cs1;
end;

function cxColorToString(AColor: TColor): string;
var
  I: Integer;
begin
  Result := '';
  for I := Low(cxColorsByName) to High(cxColorsByName) do
    if AColor = cxColorsByName[I].Color then
    begin
      Result := cxColorsByName[I].Name;
      Break;
    end
    else
      Result := ColorToPrettyName(AColor);
end;

// taken from TBXUtils, TBX Package  Alex Denisov (www.g32.org)

function Blend(C1, C2: TColor; W1: Integer): TColor;
var
  W2, A1, A2, D, F, G: Integer;
begin
  if C1 < 0 then
    C1 := GetSysColor(C1 and $FF);
  if C2 < 0 then
    C2 := GetSysColor(C2 and $FF);
  if W1 >= 100 then
    D := 1000
  else
    D := 100;
  W2 := D - W1;
  F := D div 2;
  A2 := C2 shr 16 * W2;
  A1 := C1 shr 16 * W1;
  G := (A1 + A2 + F) div D and $FF;
  Result := G shl 16;
  A2 := (C2 shr 8 and $FF) * W2;
  A1 := (C1 shr 8 and $FF) * W1;
  G := (A1 + A2 + F) div D and $FF;
  Result := Result or G shl 8;
  A2 := (C2 and $FF) * W2;
  A1 := (C1 and $FF) * W1;
  G := (A1 + A2 + F) div D and $FF;
  Result := Result or G;
end;

function IsMember(sl: TStrings; S: string): boolean;
var
  I: Integer;
begin
  Result := False;
  for I := 0 to sl.count - 1 do
    if sl.Strings[I] = S then
      Result := True;
end;

function MakePalette(BaseColor: TColor; SortOrder: TSortOrder): string;
var
  I: Integer;
  S: TStrings;
begin
  Result := '';
  S := TStringList.Create;
  try
    case SortOrder of
      soAscending: // was 239
        for I := 239 downto 0 do // was 240
          S.Add(ColorToString(HSLRangeToRGB(GetHValue(BaseColor),
            GetSValue(BaseColor), 240 - I)));
      soDescending:
        for I := 0 to 239 do
          S.Add(ColorToString(HSLRangeToRGB(GetHValue(BaseColor),
            GetSValue(BaseColor), 240 - I)));
    end;
    Result := S.Text;
  finally
    S.Free;
  end;
end;

function MakeGradientPalette(Colors: array of TColor): string;
type
  RGBArray = array [0 .. 2] of byte;
var
  I, j, k, Span: Integer;
  S: TStringList;
  sColor: string;
  Faktor: Double;
  a: RGBArray;
  B: array of RGBArray;
begin
  Result := '';
  Span := 300;
  S := TStringList.Create;
  try
    SetLength(B, High(Colors) + 1);
    for I := 0 to High(Colors) do
    begin
      Colors[I] := ColorToRGB(Colors[I]);
      B[I, 0] := GetRValue(Colors[I]);
      B[I, 1] := GetGValue(Colors[I]);
      B[I, 2] := GetBValue(Colors[I]);
    end;
    for I := 0 to High(Colors) - 1 do
      for j := 0 to Span do
      begin
        Faktor := j / Span;
        for k := 0 to 3 do
          a[k] := Trunc(B[I, k] + ((B[I + 1, k] - B[I, k]) * Faktor));
        sColor := ColorToString(RGB(a[0], a[1], a[2]));
        if not IsMember(S, sColor) then
          S.Add(sColor);
      end;
    Result := S.Text;
  finally
    S.Free;
  end;
end;

procedure SortPalColors(Colors: TStrings; SortMode: TSortMode;
  SortOrder: TSortOrder);
  function MaxPos(S: TStrings; sm: TSortMode): Integer;
  var
    I: Integer;
    first: TColor;
  begin
    Result := 0;
    first := clBlack;
    for I := 0 to S.count - 1 do
      case sm of
        smRed:
          if GetRValue(first) < GetRValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smGreen:
          if GetGValue(first) < GetGValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smBlue:
          if GetBValue(first) < GetBValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smHue:
          if GetHValue(first) < GetHValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smSaturation:
          if GetSValue(first) < GetSValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smLuminance:
          if GetLValue(first) < GetLValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smValue:
          if GetVValue(first) < GetVValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCyan:
          if GetCValue(first) < GetCValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smMagenta:
          if GetMValue(first) < GetMValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smYellow:
          if GetYValue(first) < GetYValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smBlacK:
          if GetKValue(first) < GetKValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEx:
          if GetCIExValue(first) < GetCIExValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEy:
          if GetCIEyValue(first) < GetCIEyValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEz:
          if GetCIEzValue(first) < GetCIEzValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEl:
          if GetCIElValue(first) < GetCIElValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEa:
          if GetCIEaValue(first) < GetCIEaValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEb:
          if GetCIEbValue(first) < GetCIEbValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
      end;
  end;
  function MinPos(S: TStrings; sm: TSortMode): Integer;
  var
    I: Integer;
    first: TColor;
  begin
    Result := 0;
    first := clWhite;
    for I := 0 to S.count - 1 do
      case sm of
        smRed:
          if GetRValue(first) > GetRValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smGreen:
          if GetGValue(first) > GetGValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smBlue:
          if GetBValue(first) > GetBValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smHue:
          if GetHValue(first) > GetHValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smSaturation:
          if GetSValue(first) > GetSValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smLuminance:
          if GetLValue(first) > GetLValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smValue:
          if GetVValue(first) > GetVValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCyan:
          if GetCValue(first) > GetCValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smMagenta:
          if GetMValue(first) > GetMValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smYellow:
          if GetYValue(first) > GetYValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smBlacK:
          if GetKValue(first) > GetKValue(mbStringToColor(S.Strings[I])) then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEx:
          if GetCIExValue(first) > GetCIExValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEy:
          if GetCIEyValue(first) > GetCIEyValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEz:
          if GetCIEzValue(first) > GetCIEzValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEl:
          if GetCIElValue(first) > GetCIElValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEa:
          if GetCIEaValue(first) > GetCIEaValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
        smCIEb:
          if GetCIEbValue(first) > GetCIEbValue(mbStringToColor(S.Strings[I]))
          then
          begin
            first := mbStringToColor(S.Strings[I]);
            Result := I;
          end;
      end;
  end;

var
  I, M: Integer;
  S: TStrings;
begin
  if SortMode <> smNone then
  begin
    if Colors.count = 0 then
      Exit;
    M := 0;
    S := TStringList.Create;
    S.AddStrings(Colors);
    Colors.Clear;
    for I := S.count - 1 downto 0 do
    begin
      case SortOrder of
        soAscending:
          M := MinPos(S, SortMode);
        soDescending:
          M := MaxPos(S, SortMode);
      end;
      Colors.Add(S.Strings[M]);
      S.Delete(M);
    end;
    S.Free;
  end;
end;

function ReadJASCPal(PalFile: TFileName): string;
var
  p, t, c: TStrings;
  I: Integer;
begin
  if not FileExists(PalFile) then
  begin
    raise Exception.Create('File not found');
    Exit;
  end;
  p := TStringList.Create;
  t := TStringList.Create;
  c := TStringList.Create;
  try
    p.LoadFromFile(PalFile);
    for I := 0 to p.count - 1 do
      if p.Strings[I] <> '' then
      begin
        t.Clear;
        ExtractStrings([' '], [], PChar(p.Strings[I]), t);
        if t.count = 3 then
          c.Add(ColorToString(RGB(StrToInt(t.Strings[0]),
            StrToInt(t.Strings[1]), StrToInt(t.Strings[2]))));
      end;
    Result := c.Text;
  finally
    c.Free;
    t.Free;
    p.Free;
  end;
end;

procedure SaveJASCPal(pal: TStrings; FileName: TFileName);
var
  I: Integer;
  p: TStringList;
  c: TColor;
begin
  if not FileExists(FileName) then
  begin
    raise Exception.Create('File not found');
    Exit;
  end;
  p := TStringList.Create;
  try
    p.Add('JASC-PAL');
    p.Add('0100');
    p.Add('256');
    for I := 0 to pal.count - 1 do
      if (pal.Strings[I] <> '') and not SameText(pal.Strings[I], 'clCustom') and
        not SameText(pal.Strings[I], 'clTransparent') then
      begin
        c := StringToColor(pal.Strings[I]);
        p.Add(IntToStr(GetRValue(c)) + ' ' + IntToStr(GetGValue(c)) + ' ' +
          IntToStr(GetBValue(c)));
      end;
    p.SaveToFile(FileName);
  finally
    p.Free;
  end;
end;

procedure ExchangeBytes(var w);
asm
  MOV DX,[w] // assign the word to the data register
  XCHG DL,DH // exchange low and high data values
  MOV [w],DX // assign the register data to the word
end;

procedure ExchangeChars(var S: WideString);
var
  I: Integer;
  w: Word;
begin
  for I := 1 to Length(S) do
  begin
    w := Word(S[I]);
    ExchangeBytes(w);
    S[I] := WideChar(w);
  end;
end;

function GetAcoColor(space, w, x, y, z: Word): TColor;
begin
  case space of
    0: // RGB
      Result := RGB(w div 256, x div 256, y div 256);
    1: // HSB - HSV
      Result := HSVToColor(Round(w / 182.04), Round(x / 655.35),
        Round(y / 655.35));
    2: // CMYK
      Result := CMYKToTColor(Round(100 - w / 55.35), Round(100 - x / 655.35),
        Round(100 - y / 655.35), Round(100 - z / 655.35));
    7: // Lab
      Result := LabToRGB(w / 100, x / 100, y / 100);
    8: // Grayscale
      Result := RGB(Round(w / 39.0625), Round(w / 39.0625), Round(w / 39.0625));
    9: // Wide CMYK
      Result := CMYKToTColor(w div 100, x div 100, y div 100, z div 100)
  else // unknown
    Result := RGB(w div 256, x div 256, y div 256);
  end;
end;

function ReadPhotoshopAco(PalFile: TFileName): AcoColors;
var
  F: file;
  ver, num, space, w, x, y, z, dummy: Word;
  I: Integer;
  v0Length: byte;
  v0Name: string;
  v2Length: Word;
  v2Name: WideString;
begin
  if not FileExists(PalFile) then
  begin
    raise Exception.Create('File not found');
    SetLength(Result.Colors, 0);
    SetLength(Result.Names, 0);
    Result.HasNames := False;
    Exit;
  end;
  AssignFile(F, PalFile);
  Reset(F, 1);
  // read version
  BlockRead(F, ver, sizeof(ver));
  ExchangeBytes(ver);
  if not(ver in [0, 1, 2]) then
  begin
    CloseFile(F);
    Exception.Create
      ('The file you are trying to load is not (yet) supported.'#13'Please submit the file for testing to MXS so loading of this version will be supported too');
    Exit;
  end;
  // read number of colors
  BlockRead(F, num, sizeof(num));
  ExchangeBytes(num);
  // read names
  if (ver = 0) or (ver = 2) then
  begin
    SetLength(Result.Names, num);
    Result.HasNames := True;
  end
  else
  begin
    SetLength(Result.Names, 0);
    Result.HasNames := False;
  end;
  // read colors
  SetLength(Result.Colors, num);
  for I := 0 to num - 1 do
  begin
    BlockRead(F, space, sizeof(space));
    ExchangeBytes(space);
    BlockRead(F, w, sizeof(w));
    ExchangeBytes(w);
    BlockRead(F, x, sizeof(x));
    ExchangeBytes(x);
    BlockRead(F, y, sizeof(y));
    ExchangeBytes(y);
    BlockRead(F, z, sizeof(z));
    ExchangeBytes(z);
    Result.Colors[I] := GetAcoColor(space, w, x, y, z);
    case ver of
      0:
        begin
          BlockRead(F, v0Length, sizeof(v0Length));
          SetLength(v0Name, v0Length);
          if v0Length > 0 then
            BlockRead(F, PChar(v0Name)^, v0Length);
          Result.Names[I] := v0Name;
        end;
      2:
        begin
          BlockRead(F, dummy, sizeof(dummy));
          BlockRead(F, v2Length, sizeof(v2Length));
          ExchangeBytes(v2Length);
          SetLength(v2Name, v2Length - 1);
          if v2Length > 0 then
          begin
            BlockRead(F, PWideChar(v2Name)^, 2 * (v2Length - 1));
            ExchangeChars(v2Name);
          end;
          Result.Names[I] := v2Name;
          BlockRead(F, dummy, sizeof(dummy));
        end;
    end;
  end;
  CloseFile(F);
end;

function ReadPhotoshopAct(PalFile: TFileName): string;
var
  F: file;
  R, G, B: byte;
  S: TStringList;
  I: Integer;
begin
  if not FileExists(PalFile) then
  begin
    raise Exception.Create('File not found');
    Result := '';
    Exit;
  end;
  S := TStringList.Create;
  try
    AssignFile(F, PalFile);
    Reset(F, 1);
    for I := 0 to 255 do
    begin
      BlockRead(F, R, sizeof(R));
      BlockRead(F, G, sizeof(G));
      BlockRead(F, B, sizeof(B));
      S.Add(ColorToString(RGB(R, G, B)));
    end;
    Result := S.Text;
  finally
    S.Free;
  end;
  CloseFile(F);
end;

end.
